package com.qmth.ops.biz.service;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.ops.biz.dao.DocSupplierDao;
import com.qmth.ops.biz.domain.DocSupplier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

@Service
public class DocSupplierService extends ServiceImpl<DocSupplierDao, DocSupplier> {

    @Resource
    private DocSupplierDao supplierDao;

    @Transactional
    public DocSupplier insert(DocSupplier supplier) {
        supplier.setCreateTime(System.currentTimeMillis());
        supplier.setUpdateTime(supplier.getCreateTime());
        supplier.setEnable(true);
        supplierDao.insert(supplier);
        return supplier;
    }

    @Transactional
    public void update(DocSupplier supplier) {
        supplierDao.update(null, new LambdaUpdateWrapper<DocSupplier>()
                .set(supplier.getName() != null, DocSupplier::getName, supplier.getName())
                .set(supplier.getUrl() != null, DocSupplier::getUrl, supplier.getUrl())
                .set(supplier.getKey() != null, DocSupplier::getKey, supplier.getKey())
                .set(supplier.getSecret() != null, DocSupplier::getSecret, supplier.getSecret())
                .set(supplier.getQps() != null, DocSupplier::getQps, supplier.getQps())
                .set(supplier.getEnable() != null, DocSupplier::getEnable, supplier.getEnable())
                .set(DocSupplier::getUpdateTime, System.currentTimeMillis()).eq(DocSupplier::getId, supplier.getId()));
    }

}
